<template>
  <div class="itinerary-calendar">
    <q-date
      v-model="selectedDates"
      multiple
      :default-year-month="rosterMonth"
      :events="eventsDate"
      event-color="orange"
      @navigation="handleNavigation"
    >
      <div class="flex gap-10px">
        <q-btn @click="selectedAllDate">
          全選
        </q-btn>
        <q-btn @click="clearSelectedDates">
          取消選擇
        </q-btn>
        <q-btn
          color="orange"
          text-color="black"
          @click="removeDayItinerary"
        >
          刪除日程
        </q-btn>
      </div>
    </q-date>
  </div>
</template>

<script lang='ts' setup>
import { computed, ref, watch } from 'vue';
import dayjs from 'dayjs';
import { range } from 'lodash';

import { useQuasar } from 'quasar';
import { useMainStore } from '../../store/main.store';

interface OnNavigationParams {
  year: number;
  month: number;
}

const emit = defineEmits<{
  (e: 'update:selectedDates', value: string[]): void;
  (e: 'update:rosterMonth', value: string): void;
}>();

const $q = useQuasar();
const store = useMainStore();

const dayItineraries = computed(() => store.dayItineraries);

/** 已選擇的日期 */
const selectedDates = ref<string[]>([]);
watch(selectedDates, (val) => {
  emit('update:selectedDates', val);
});
function clearSelectedDates() {
  selectedDates.value = [];
}
function selectedAllDate() {
  const dateObj = dayjs(`${rosterMonth.value}/01`);
  const daysInMonth = dateObj.daysInMonth();

  const days = range(0, daysInMonth);

  selectedDates.value = days.map((number) => {
    return dateObj.add(number, 'd').format('YYYY/MM/DD');
  });
}

/** 班表月份。YYYY/MM */
const rosterMonth = ref(dayjs().format('YYYY/MM'));

function handleNavigation({ year, month }: OnNavigationParams) {
  const mm = `${month}`.padStart(2, '0');

  rosterMonth.value = `${year}/${mm}`;
}
watch(rosterMonth, (val) => {
  emit('update:rosterMonth', val);
});

const eventsDate = computed(() => {
  return dayItineraries.value.map((dayItinerary) => dayItinerary.date);
});

/** 刪除日程 */
function removeDayItinerary() {
  if (selectedDates.value.length === 0) {
    return;
  }

  $q.notify({
    type: 'warning',
    message: `確認刪除「${selectedDates.value.join('、')}」的職缺嗎？`,
    multiLine: true,
    actions: [
      {
        label: '確認',
        handler: () => {
          selectedDates.value.forEach((date) => {
            store.removeDayItinerary(date);
          });
        },
      },
      {
        label: '取消',
        class: 'bg-primary',
        color: 'white',
      },
    ],
  });
}
</script>
